#ifndef __MOVELIST__
#define __MOVELIST__
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
using namespace std ;

class MoveList {

	char list[100];		//actual list of moves
	int lngth;			//length of list;
	int lngthtwst;		//number of twists
	string current_solution;
	bool solutionFoundQ_;

public:
	MoveList(): lngth(0), lngthtwst(0), current_solution("No Solution Found."), solutionFoundQ_(0) {}
	inline void push(char m){ 
		list[lngth++]=m; if(m==0) lngthtwst++;
	}
	inline char pull() {
		if(lngth){
			if(list[--lngth]==0) lngthtwst--;
			return list[lngth];
		}else{
			return 0;
		}
	}
	inline int readlist(char a){ return a<lngth? list[a] : 0; }
	inline int length() { return lngth; }
	inline int lengthtwist() { return lngthtwst; }
	inline string record() { return current_solution; }
	inline bool solutionFoundQ() { return solutionFoundQ_; }
	inline void outputturn(ostream& os, int a){
		int b = (12-a) % 12;
		if(b<=6) os<<' '<<b;
		else os<<'-'<<(12-b);
	}
	inline void outputmove(ostream& os, int a, int b){
		os<<'(';
		outputturn(os,a);
		os<<',';
		outputturn(os,b);
		os<<')';
	}
	inline void print(ostream& os){
		
		current_solution="";
		
		int b,c;
		for(int a=0; a<lngth; a++){
			stringstream buffy;
			b=list[a];
			if(b==0) buffy<<'/';
			else if(b>0){
				if(a<lngth-1 && (c=list[a+1])<0){
					outputmove(buffy,b,-c); a++;
				}else outputmove(buffy,b,0);
			}else if(b<0) outputmove(buffy,0,-b);
			current_solution = buffy.str() + current_solution;
		}
		

		//os << recrd;
		while (current_solution.length() < 105) {
			current_solution += " ";
		}
		stringstream buffy2;
		buffy2<<" ["<<lngthtwst<<'|'<<lngth<<']';
		current_solution += buffy2.str();
		
		solutionFoundQ_ = 1;
	}
};

#endif
